<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
   <meta name="Author" content="Todd Riggins">
   <meta name="GENERATOR" content="Mozilla/4.61 [en] (Win98; I) [Netscape]">
   <title>EXOTICA: BASIC DESIGN</title>
</head>
<body background="images/exotica_bg.gif" bgcolor="#000000" text="#ffffff">
<center>
<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><center><b><font color="maroon"><font size=+2>
<a NAME="INTRODUCTION"></a>EXOTICA: BASIC DESIGN
</font></font></b></center></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
<A href="e_api.html">API MAIN PAGE</A><br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">
<center><b><font color="maroon">DESIGN</font></b></center>
<hr WIDTH="100%">
First off, I'm not a design expert. There are many ways to design your program to
whatever meets your needs. This section is just my humble attempt to help beginners to
get a grasp of a basic way to make thier programs run.<p>
Here I will give two examples, one in the C language code and the other in the
Euphoria code. This code shows how to run a basic Exotica example by including my
emain.c and emain.h files if you are programming in C and by including the emain.ew file
if you are programming in Euphoria. The emain file sets up a window for Extoica to run in.
You can change the emain file to however you need it for your program or even not use it
at all if you want to make your own. Remmember, I'm not here to teach how to write C
code, Euphoria code and what the Win32 functions are all about. Here, I'm assuming
you already know that.<p>
The MainLoop_Init, MainLoop and MainLoop_Exit functions are needed by the emain file
because the code there calls these functions to be executed. The MainLoop_Init function is
a good place to Initialize things and executing Exotica's Initialize routines. The
MainLoop function is where you would want to blit graphics, process input and play sounds. It's
where your main guts of your program should be executed. The MainLoop_Exit function is a 
a good place to free memory that you may have allocated and where you would do a 
EXOTICA_EXIT() call to shutdown Exotica when exiting your program.
When returning a value of 1 from the MainLoop_Init, MainLoop and the MainLoop_Exit functions,
that will make your program end. Ussually this is because there was an error somewhere. <p> 

The code below demostrates a basic design.<br>
<hr WIDTH="100%">
<center><b><font color="maroon">C - CODE</font></b></center>
<hr WIDTH="100%">
// <br>
// A Basic Program For EXOTICA that doesn't do anything except<br>
// show a black screen. The emain.ew file has it were the user can<br>
// simply press the ESC key to exit.<br>
// <br>
<br>
#include "..\emain.h"<br>
<br>
// stores return values from functions<br>
int funcval;<br>
<br>
int MainLoop_Init( void )<br>
{<br>
<br>
&nbsp;-- the EXOTICA's 'edx.dll' must be supplied with the HWND handle<br>
&nbsp;-- and the HINSTANCE handle  of your window...<br>
&nbsp;-- currently, 'hwnd' and 'hinstApp' holds the current handles<br>
&nbsp;-- of your window which is defined in the 'emain.ew' file<br>
&nbsp;-- as globals.<br>
&nbsp;if (EXOTICA_INIT(hwnd,hinstApp)!=0) return 1;<br>
<br>
&nbsp;// Set up Direct Draw<br>
&nbsp;funcval=DDRAW_INIT();<br>
&nbsp;if (funcval != 0)<br>
&nbsp;{<br>
&nbsp;&nbsp;ERROR_MESSAGE("DDRAW_INIT FAILED");<br>
&nbsp;&nbsp;return 1;<br>
&nbsp;}<br>
&nbsp;<br>   
&nbsp;funcval = SET_VIDEO_MODE(640, 480, 16);<br>
&nbsp;if (funcval != 0)<br>
&nbsp;{<br>
&nbsp;&nbsp;ERROR_MESSAGE("SET_VIDEO_MODE FAILED");<br>
&nbsp;&nbsp;return 1;<br>
&nbsp;}<br>
<br>	
&nbsp;return 0;<br>
}<br>
<br>
int MainLoop( void )<br>
{<br>
&nbsp;// Clear Screen with color 0<br>
&nbsp;CLEAR_SURFACE(0);<br>
<br>
&nbsp;// Catch any Exotica errors and exit gracefully...<br>
&nbsp;if (ON_ERROR()==1) return 1;<br>
<br>
&nbsp;// Flip surface<br>
&nbsp;SURFACE_FLIP();<br>
<br>
&nbsp;return 0;<br>
}<br>
<br>
int MainLoop_Exit( void )<br>
{<br>
&nbsp;// Shutdown EXOTICA. This must be called at the program's end<br>
&nbsp;// when you have done an EXOTICA_INIT at the beginning of your program.<br>
&nbsp;EXOTICA_EXIT();<br>
<br>
&nbsp;return 0;<br>
}<br>
<br>
<hr WIDTH="100%">
<center><b><font color="maroon">EUPHORIA - CODE</font></b></center>
<hr WIDTH="100%">
--<br>
-- A Basic Program For EXOTICA that doesn't do anything except<br>
-- show a black screen. The emain.ew file has it were the user can<br>
-- simply press the ESC key to exit.<br>
--<br>
include emain.ew<br>
<br>
-- stores return values from functions<br>
atom funcval<br>
<br>
function MainLoop_Init()<br>
<br>
&nbsp;-- the EXOTICA's 'edx.dll' must be supplied with the HWND handle<br>
&nbsp;-- and the HINSTANCE handle  of your window...<br>
&nbsp;-- currently, 'hwnd' and 'hInst' holds the current handles<br>
&nbsp;-- of your window which is defined in the 'emain.ew' file<br>
&nbsp;-- as globals.<br>
&nbsp;funcval=c_func(EXOTICA_INIT,{hwnd,hInst})<br>
&nbsp;if funcval !=0 then return 1 end if<br>
<br>
&nbsp;-- Set up Direct Draw<br>
&nbsp;funcval=c_func(DDRAW_INIT,{NULL})<br>
&nbsp;if funcval != 0 then<br>
&nbsp;&nbsp;c_proc(ERROR_MESSAGE,{allocate_string("DDRAW_INIT")})<br>
&nbsp;&nbsp;return 1<br>
&nbsp;end if<br>
<br>
&nbsp;funcval = c_func( SET_VIDEO_MODE, {640, 480, 16})<br>
&nbsp;if funcval != 0 then<br>
&nbsp;&nbsp;c_proc(ERROR_MESSAGE,{allocate_string("SET_VIDEO_MODE")})<br>
&nbsp;&nbsp;return 1<br>
&nbsp;end if<br>
<br>
&nbsp;return 0<br>
end function<br>
<br>
function MainLoop()<br>
<br>
&nbsp;-- Clear Back Buffer Surface before redrawing...<br>
&nbsp;funcval = c_func( CLEAR_SURFACE, {0})<br>
&nbsp;if funcval != 0 then<br>
&nbsp;&nbsp;c_proc(ERROR_MESSAGE,{allocate_string("CLEAR_SURFACE")})<br>
&nbsp;&nbsp;return 1<br>
&nbsp;end if<br>
<br>
&nbsp;-- Catch any Exotica errors and exit gracefully...<br>
&nbsp;if c_func(ON_ERROR,{NULL})=1 then return 1 end if<br>
<br>
&nbsp;--Flip the back buffer surface to the Primary surface to<br>
&nbsp;--let us see the updated drawings<br>
&nbsp;funcval=c_func( SURFACE_FLIP, {0})<br>
<br>
&nbsp;return 0<br>
end function<br>
<br>
function MainLoop_Exit()<br>
<br>
&nbsp;-- Shutdown EXOTICA. This must be called at the program's end<br>
&nbsp;-- when you have done an EXOTICA_INIT at the beginning of your program.<br>
&nbsp;c_proc(EXOTICA_EXIT,{NULL})<br>
<br>
&nbsp;return 0<br>
&nbsp;end function<br>
<br>
--- Must get return_ids for above 3 MainLoop functions.<br>
Get_MainLoop__Init_Id(routine_id("MainLoop_Init"))<br>
Get_MainLoop_Id(routine_id("MainLoop"))<br>
Get_MainLoop__Exit_Id(routine_id("MainLoop_Exit"))<br>
<br>
--- Now, start your creation! :)<br>
WinMain()<br>
<br>
</font></b></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
<A href="e_api.html">API MAIN PAGE</A><br>
</font></b></td></tr>
</table>

</center>
</body>
</html>
